package convert;

require 5.004;
use strict;

use File::Copy;
use nm;
use nm::times;
use LIRS;

$nm::convert::version = q(1.00);

my $Times = new nm::times;
my $LIRS = new LIRS;


sub ver{
	return $nm::convert::version;
}


sub convert{
	my $conf = shift;

print "\012\"convert::convert\" start\012";

	$nm::cf::conv::in = undef;
	$nm::cf::conv::hinaout = undef;
	$nm::cf::conv::diout = undef;

print "read cfg file: $nm::cf::bin$conf\012";
	require qq($nm::cf::bin$conf);
	delete($INC{qq($nm::cf::bin$conf)});

	# ¾ǡν񤭽Ф
print "\012output other file format\012";
	if($nm::cf::conv::hinaout){
		open(HOUT, ">$nm::cf::tmp$nm::cf::conv::hinaout.$$");
		flock(HOUT, 2) if($nm::cf::os eq 'unix');
	}
	if($nm::cf::conv::diout){
		open(DOUT, ">$nm::cf::tmp$nm::cf::conv::diout.$$");
		flock(DOUT, 2) if($nm::cf::os eq 'unix');
		my $di = "HINA/2.1\012";
		$di .= "User-Agent: $nm::UserAgent\012";
		$di .= $Times->showdate("$nm::now", "Date: %ee%, %DD% %nn% %YYYY% %HH%:%TT%:%SS% GMT");
		$di .= "\012\012";
		print DOUT $di;
	}

	# LIRSեɤ߹
	open(SRC, "$nm::cf::ext$nm::cf::conv::in") || die "Can't open get last modified time information file\012";
	flock(SRC, 2) if($nm::cf::os eq 'unix');
	while(<SRC>){
		unless(/^#/){
			if(/^LIRS.*/){
				my ($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = $LIRS->tolist($_);
				my ($vurl, $key, $option, $etc, $refer) = split(",", $optional);

				next if($refer eq "LENGTH" || $refer eq "PUSH");

				if($nm::cf::conv::hinaout){
					# hina.txtߴκ
					my $remold = "2";
					$remold = "1" if($nm::now < $lmd + $nm::expiresCount - (60 * 30));
					$remold = "0" if($refer eq "FILE" || $refer eq "HEAD" || $refer eq "GET");
					my $hr;
					if($time == 0){
						$hr = "<!--HINA_REMOTE_OUT-->";
						$hr .= "<A HREF=\"$url\">$title</A>";
					}else{
						$hr = $Times->showdate(($time + $nm::cf::localTimeZone), "<!--HINA_OK %YYYY%/%MM%/%DD% %HH%:%TT%");
						$hr .= " [$remold]-->";
						$hr .= "<A HREF=\"$url$option\">$title</A>";
					}
					$hr .= "$author<BR>\012";
					$hr = &nm::eucconv($hr);
					print HOUT $hr;
#					print HOUT "<!--HINA_UNKNOWN--><A HREF=\"$url\">$title</A>$author<BR>\012";
				}

				if($nm::cf::conv::diout){
					# DIκ
					my $di = "Url: $url\012";
#					$di .= "Title: $title\012" if($title ne "0");
#					$di .= "Author-Name: $author\012" if($author ne "0");
					my $expire_string;
					if($time eq "0"){
						$expire_string = $Times->showdate('0', "%ee%, %DD% %nn% %YYYY% %HH%:%TT%:%SS% GMT");
					}else{
						$di .= $Times->showdate("$time", "Last-Modified: %ee%, %DD% %nn% %YYYY% %HH%:%TT%:%SS% GMT");
						$di .= "\012";
						$di .= $Times->showdate("$lmd", "Last-Modified-Detected: %ee%, %DD% %nn% %YYYY% %HH%:%TT%:%SS% GMT");
						$di .= "\012";
						$expire_string = $Times->showdate(($lmd + $nm::expiresCount), "%ee%, %DD% %nn% %YYYY% %HH%:%TT%:%SS% GMT");
					}
					$di .= "Expire: ".$expire_string."\012";
					$di .= "Expires: ".$expire_string."\012";
					$di .= "Content-Length: $length\012" if($length > 0);
					if($refer eq "HEAD" || $refer eq "GET" || $refer eq "FILE"){
						$di .= "Authorized: $nm::UserAgent\012";
						$di .= "Authorized-Url: $nm::cf::referer\012";
#						$di .= "Method: $refer\012";
					}elsif($refer eq "CACHE"){
						$di .= "Authorized-Url: $nm::cf::referer\012" if($nm::cf::referer ne "0");
#						$di .= "Method: CACHE\012";
					}else{
						$di .= "Authorized-Url: $remote\012" if($remote ne "0");
#						$di .= "Method: REMOTE\012";
					}
					$di .= "\012";
					$di = &nm::eucconv($di);
					print DOUT $di;
				}

			}
		}
	}
	close(SRC);


	if($nm::cf::conv::hinaout){
		close(HOUT);
		move("$nm::cf::tmp$nm::cf::conv::hinaout.$$", "$nm::cf::ext$nm::cf::conv::hinaout");
print "  output hina.txt file\012";
	}
	if($nm::cf::conv::diout){
		close(DOUT);
		move("$nm::cf::tmp$nm::cf::conv::diout.$$", "$nm::cf::ext$nm::cf::conv::diout");
print "  output DI file\012";
	}

print "\"convert::convert\" end\012";
}



1;
