package detect;

require 5.004;
use strict;

use File::Copy;
use nm;
use nm::files;
use nm::times;
use nm::https;
use LIRS;

$nm::detect::version = q(1.00);

my $Files = new nm::files;
my $Times = new nm::times;
my $HTTPs = new nm::https;
my $LIRS = new LIRS;

my @remlist;


sub ver{
	return $nm::detect::version;
}


sub detect{
	my $conf = shift;
	my $opt = shift;

print "\012\"detect::detect\" start\012";

	$nm::now = time;
	$nm::info_ref = {};
	$nm::remote_ref = {};
	@nm::urllist = ();

	@remlist = ();

	$nm::cf::det::rem = undef;
	@nm::cf::det::cfg = ();
	$nm::cf::det::out = undef;

print "read cfg file: $nm::cf::bin$conf\012";
	require qq($nm::cf::bin$conf);
	delete($INC{qq($nm::cf::bin$conf)});

	if($nm::cf::re){
		if(-e "$nm::cf::re"){
print "adjust push-LIRS\012";
			my @remdat = $Files->read_file("$nm::cf::re", $nm::cf::os);
			&analysis('PUSH', $nm::cf::localTimeZone, \@remdat);
			my $adj = &output(\@remlist, 'z');
			if(length($adj) > 10){
				$Files->write_file("$nm::cf::re", "$adj", $nm::cf::os);
			}else{
				unlink("$nm::cf::re");
			}
			$nm::info_ref = {};
			@remlist = ();
		}
	}

#################$opt = "noremote";

	# cfgե(ե)ɤ߹
print "\012read cfg file and remote setting.\012";
	if($opt eq "" || $opt =~ /noget/i){
		&nm::readcfg(\@nm::cf::det::cfg, $nm::cf::det::rem);
	}elsif($opt =~ /noremote/i){
		&nm::readcfg(\@nm::cf::det::cfg);
	}

######################print @nm::urllist;

	if($nm::cf::re){
		if(-e "$nm::cf::re"){
print "remote info file get start: push-LIRS\012";
			# pushLIRSե뤬¸ߤȤ
			my @remdat = $Files->read_file("$nm::cf::re", $nm::cf::os);
			&analysis('PUSH', $nm::cf::localTimeZone, \@remdat);
		}
	}

	if($opt !~ /noremote/i){
		# ⡼ȾhttpǼŬ
print "\012get site information from remote info file\012";


		foreach my $i (keys %$nm::remote_ref){
print "remote info file get start: $nm::remote_ref->{$i}->{'URL'}\012";

			my @remdat;
			my $remurl = $nm::remote_ref->{$i}->{'GET_URL'};
			my $file = $nm::remote_ref->{$i}->{'FILE'};

			my ($protocol, $host, $port, $userfile) = $HTTPs->parseURL($remurl);

			# ⡼Ⱦ
			if($protocol eq "file"){
				if(-e $userfile){
					if($Files->file_time($userfile) > $Files->file_time("$nm::cf::tmp$file")){
						$nm::remote_ref->{$i}->{'LASTMOD'} = $Files->file_time($userfile);
						copy($userfile, "$nm::cf::tmp$file.$$");
						if($remurl =~ /.*\.gz$/i){
							move("$nm::cf::tmp$file.$$", "$nm::cf::tmp$file".".gz");
							$LIRS->extractLIRS($nm::cf::gzip, "$nm::cf::tmp$file".".gz");
						}else{
							move("$nm::cf::tmp$file.$$", "$nm::cf::tmp$file");
						}
					}else{
print "  not get, remote file is older: " . $nm::remote_ref->{$i}->{'GET_URL'} . "\012";
					}
				}
				@remdat = $Files->read_file("$nm::cf::tmp$file", $nm::cf::os);

			}else{
				my $lmdtime;
				if(-e "$nm::cf::tmp$file"){
					$lmdtime = $Files->file_time("$nm::cf::tmp$file");
				}else{
					$lmdtime = 0;
				}

				my @tmpdat = $HTTPs->http_access($remurl, 'HEAD', $lmdtime, $nm::UserAgent, $nm::cf::referer, $nm::cf::http_proxy);

				if($tmpdat[0] =~ /200/){
					for(@tmpdat){
						if(/last-modified(.+)/i){
							$nm::remote_ref->{$i}->{'LASTMOD'} = $Times->timeconv($1, $nm::cf::localTimeZone);
						}
					}

					@tmpdat = ();
					my $tmpdat = $HTTPs->http_access($remurl, 'GET', $lmdtime, $nm::UserAgent, $nm::cf::referer, $nm::cf::http_proxy);

					if($tmpdat =~ /^\d\d\d$/){
print "  ".$tmpdat;
print " remote file not get: " . $nm::remote_ref->{$i}->{'GET_URL'} . "\012";

					}else{
						$Files->write_file("$nm::cf::tmp$file.$$", $tmpdat, $nm::cf::os);
						if($remurl =~ /.*\.gz$/i){
							move("$nm::cf::tmp$file.$$", "$nm::cf::tmp$file".".gz");
							$LIRS->extractLIRS($nm::cf::gzip, "$nm::cf::tmp$file".".gz");
						}else{
							move("$nm::cf::tmp$file.$$", "$nm::cf::tmp$file");
						}
					}

				}elsif($tmpdat[0] =~ /HTTP/){
print "  remote file not get: " . $nm::remote_ref->{$i}->{'GET_URL'} . "\012";

				}else{
print "  cannot get remote file: " . $nm::remote_ref->{$i}->{'GET_URL'} . "\012";

				}
				@remdat = $Files->read_file("$nm::cf::tmp$file", $nm::cf::os);

			}

			# ⡼ȥե뤫
			&analysis($nm::remote_ref->{$i}->{'URL'}, $nm::remote_ref->{$i}->{'LAG'}, \@remdat);
			@remdat = ();
		}
	}

	# åɤ߹
print "\012read cache file\012";
	open(FILE, "$nm::cf::ext$nm::cf::det::out");
	flock(FILE, 2) if($nm::cf::os eq 'unix');
	while(<FILE>){
		my ($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = $LIRS->tolist($_);
		$optional =~ s/\\,/%2c/g;
		my ($vurl, $key, $option, $etc, $nul) = split(",", $optional);
		$vurl =~ s/%2c/\,/ig;
		$key =~ s/%2c/\,/ig;
		$option =~ s/%2c/\,/ig;
		$etc =~ s/%2c/\,/ig;

		$url =~ s/%7e/~/io;
#		$url =~ tr/A-Z/a-z/;
		$url = &nm::urlkey($url);
		&set_info("CACHE", $url, $time, $lmd, $length, $lag, $title, $author, $remote, $vurl, $key, $option, $etc);
	}
	close(FILE);

	# $vurlξ$urlͤŬ
	my $rt = 0;
	foreach my $e (@nm::urllist){
		my $ef = &nm::urlkey($e);
		if($nm::info_ref->{$ef}->{'ALIAS'}){
			if($nm::info_ref->{$ef}->{'LASTMOD'}){
				my $yr = &nm::urlkey($nm::info_ref->{$ef}->{'ALIAS'});

				my $refer = $nm::info_ref->{$ef}->{'REFER'};
				my $time = $nm::info_ref->{$ef}->{'LASTMOD'};
				my $lmd = $nm::info_ref->{$ef}->{'LMD'};
				my $lag =  $nm::info_ref->{$ef}->{'LAG'};
				my $length = $nm::info_ref->{$ef}->{'LENGTH'};
				my $title =  $nm::info_ref->{$ef}->{'TITLE'};
				my $author =  $nm::info_ref->{$ef}->{'AUTHOR'};
				my $remote =  $nm::info_ref->{$ef}->{'REMOTE'};
				my $vurl = $nm::info_ref->{$yr}->{'VURL'};
				my $key = $nm::info_ref->{$yr}->{'KEY'};
				my $option = $nm::info_ref->{$yr}->{'OPTION'};
				my $etc = $nm::info_ref->{$yr}->{'ETC'};

				&set_info($refer, $yr, $time, $lmd, $length, $lag, $title, $author, $remote, $vurl, $key, $option, $etc);
			}
			splice(@nm::urllist, $rt, 1);
		}
		$rt++;
	}

	if($opt !~ /noget/i){
		# Ȥľ(HEAD, GET, FILE, LENGTH)
print "\012direct get site information\012";
		foreach my $k (@nm::urllist){
			my $kk = &nm::urlkey($k);

			if($nm::info_ref->{$kk}->{'REFER'} eq "CACHE" || $nm::info_ref->{$kk}->{'LASTMOD'} <= 0){
print "get site information: $k\012";
				&site_access($k, $nm::info_ref->{$kk}->{'LASTMOD'});

			}else{
				my $y = $nm::info_ref->{$kk}->{'VURL'};
				if($y =~ m%^file://%i){
print "get site information: $k\012";
					&site_access($k, '0');
				}
			}
		}
	}

print "\012output data\012";

	open(OUT, ">$nm::cf::tmp$nm::cf::det::out.$$");
	flock(OUT, 2) if($nm::cf::os eq 'unix');
	if(@nm::urllist){
		print OUT &output(\@nm::urllist);
	}else{
		# åȥ̵꤬
		print OUT &output(\@remlist);
	}
	close(OUT);
	move("$nm::cf::tmp$nm::cf::det::out.$$", "$nm::cf::ext$nm::cf::det::out");


	# LIRSեΰ
	$LIRS->compressLIRS($nm::cf::gzip, "$nm::cf::ext$nm::cf::det::out");
	print "output LIRS file\012";

	($nm::info_ref, $nm::remote_ref, @nm::urllist) = undef;

print "\"detect::detect\" end\012";
}


##
# ɤޤ줿ȾޤȤLIRS֤
sub output{
	my $arrayref = shift;
	my $opt = shift;
	my @array = @$arrayref;
	my $ret;

	foreach my $masterurl (@array){
		my ($time, $lmd, $lag, $length, $title, $author, $remote, $s, $vurl, $key, $option, $etc, $refer, $remold, $hr, $r);
		my $u = &nm::urlkey($masterurl);

		$refer = $nm::info_ref->{$u}->{'REFER'};
		if($opt =~ /z/){
			next unless($refer);
		}
		$time = $nm::info_ref->{$u}->{'LASTMOD'};
		$lmd = $nm::info_ref->{$u}->{'LMD'};
		$lag = $nm::info_ref->{$u}->{'LAG'};
		$length = $nm::info_ref->{$u}->{'LENGTH'};
		$title = $nm::info_ref->{$u}->{'TITLE'};
		$author = $nm::info_ref->{$u}->{'AUTHOR'};
		$remote =  $nm::info_ref->{$u}->{'REMOTE'};
		$vurl = $nm::info_ref->{$u}->{'VURL'};
		$key = $nm::info_ref->{$u}->{'KEY'};
		$option = $nm::info_ref->{$u}->{'OPTION'};
		$etc = $nm::info_ref->{$u}->{'ETC'};

		$lag = $nm::cf::localTimeZone if($lag eq "");

		$option = $Times->showdate(($time + $lag), "$option");

		$vurl =~ s%file://.+?$%%gm;
		$vurl =~ s/,/\\,/g;
		$key =~ s/,/\\,/g;
		$option =~ s/,/\\,/g;
		$etc =~ s/,/\\,/g;

		# LIRSκ
		$s = "$vurl,$key,$option,$etc,$refer";
		$r = $LIRS->toLIRS($time, $lmd, $lag, $length, $masterurl, $title, $author, $remote, $s);

		$ret .= $r;
	}
	$ret = &nm::eucconv($ret);
	return $ret;
}


##
# 򥻥åȤ롣
sub set_info($$$$;$$$$$$$$){
	my ($refer, $burl, $time, $lmd, $length, $lag, $title, $author, $remote, $vurl, $key, $option, $etc) = @_;
	my $url = &nm::urlkey($burl);
	$url =~ s/%7e/~/io;
	my $detect;
	my $ret;
	my $y = $nm::info_ref->{$url}->{'VURL'};
	my $z;

	$title = undef if($title =~ /\sUNKNOWN/i);
	$author = undef if($author =~ /\sUNKNOWN/i);
	$lag = undef if($lag eq "0");

	if($refer ne "CACHE"){
		$nm::info_ref->{$url}->{'LAG'} = $lag if($lag ne undef && $nm::info_ref->{$url}->{'LAG'} eq undef);
		$nm::info_ref->{$url}->{'TITLE'} = $title if($title ne undef && $nm::info_ref->{$url}->{'TITLE'} eq undef);
		$nm::info_ref->{$url}->{'AUTHOR'} = $author if($author ne undef && $nm::info_ref->{$url}->{'AUTHOR'} eq undef);
		$nm::info_ref->{$url}->{'LENGTH'} = $length if($refer ne "LENGTH");
	}

	if(@nm::urllist){
		for(@nm::urllist){
			my $r = $_;
			$r = &nm::urlkey($r);
			if($url eq $r){
				$z = 1;
				last;
			}
		}
		return undef if($z ne "1");
	}

	if($y =~ m%^file://%i){
		return undef if($refer ne "FILE");
	}

	if($time > $nm::now){
print "  wrong modified data...\012" if($refer =~ /(HEAD|GET|FILE|LENGTH)/);
		return undef;
	}
	if($lmd <= 0){
print "  wrong detect data...\012" if($refer =~ /(HEAD|GET|FILE|LENGTH)/);
		return undef;
	}

	if($refer eq "LENGTH"){

	}elsif($refer eq "CACHE"){
		if($nm::info_ref->{$url}->{'LASTMOD'} > 0){
			return undef;
		}
	}else{
		if($nm::now - (60 * 60 * 24 * 365 * 5) >= $time){
print "  cannot get information or older 5 years...\012" if($refer =~ /(HEAD|GET|FILE)/);
			return undef;
		}
	}

	$detect = $nm::now - $lmd;
	if($detect > $nm::expiresCount){
print "  expired...\012" if($refer =~ /(HEAD|GET|FILE|LENGTH)/);
		return undef;
	}

	if($nm::info_ref->{$url}->{'LASTMOD'} > $time){
print "  older...\012" if($refer =~ /(HEAD|GET|FILE)/);
		return undef;
	}

	if($nm::info_ref->{$url}->{'LMD'} > $lmd){
print "  oldest...\012" if($refer =~ /(HEAD|GET|FILE|LENGTH)/);
		return undef;
	}

	if($nm::info_ref->{$url}->{'LASTMOD'} == $time){
		if($nm::info_ref->{$url}->{'LMD'} >= $lmd){
print "  oldest...\012" if($refer =~ /(HEAD|GET|FILE|LENGTH)/);
			return undef;
		}
	}

	$nm::info_ref->{$url}->{'REFER'} = $refer;
	$nm::info_ref->{$url}->{'LASTMOD'} = $time;
	$nm::info_ref->{$url}->{'LMD'} = $lmd;
	$nm::info_ref->{$url}->{'LENGTH'} = $length;
	$nm::info_ref->{$url}->{'REMOTE'} = $remote;
	$ret = 1;

#	if($nm::info_ref->{$url}->{'VURL'} eq ""){
#		if($vurl !~ m%file://.+?$%i){
#			$nm::info_ref->{$url}->{'VURL'} = $vurl if($vurl);
#		}
#	}
#	if($nm::info_ref->{$url}->{'KEY'} eq ""){
#		$nm::info_ref->{$url}->{'KEY'} = $key if($key);
#	}

print "  $time\012" if($refer =~ /(HEAD|GET|FILE|LENGTH)/);
#print "$url: use cache\012" if($refer eq "CACHE");

	return $ret;
}


##
# LIRS, DI,hina.txtʤɤβ
sub analysis{
	my $rem = shift;
	my $remlag = shift;
	my $anlref = shift;
	my @anl = @$anlref;

	my $expires;
	my ($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional);
	my $ret;

	for(@anl){
		# EUCˤꤤ
		$_ = &nm::eucconv($_);
		s/\015\012/\012/og;
		s/\015/\012/og;

		# LIRSɤߤȤʬ
		if(/^LIRS.*/i){
			($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = $LIRS->tolist($_);
			push(@remlist, $url) unless(grep(/\Q$url\E/, @remlist));
			$ret = &set_info($rem, $url, $time, $lmd, $length, $lag, $title, $author, $remote);
			($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = undef;

		# DIɤߤȤʬ
		}elsif(/^URL:\s*(.*)\012/i){
			$url = $1;
			$url =~ s/[\?&]\d+//;
		}elsif(/^Last-Modified:\s*(.*)\012/i){
			$time = $Times->timeconv($1, $remlag);
		}elsif(/^Last-Modified-Detected:\s*(.*)\012/i){
			$lmd = $Times->timeconv($1, $remlag);
		}elsif(/^Title:\s*(.*)\012/i){
			$title = $1;
		}elsif(/^Content-Length:\s*(.*)\012/i){
			$length = $1;
		}elsif(/^Author-Name:\s*(.*)\012/i){
			$author = $1;
		}elsif(/^Authorized-Url:\s*(.*)\012/i){
			$remote = $1;
		}elsif(/^Expire.?:\s*(.*)\012/i){
			$expires = $Times->timeconv($1, $remlag);
		}elsif(/^$/){
			if($url ne "" && $time ne ""){
				if($expires > $nm::now){
					$remote = $rem unless($remote);
					$length = 0 unless($length);
					push(@remlist, $url) unless(grep(/\Q$url\E/, @remlist));
#					$lmd = $expires - $expiresCount;
					$ret = &set_info($rem, $url, $time, $lmd, $length, $remlag, $title, $author, $remote);
				}
			}
			($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional, $expires) = undef;

		# hina.txt
		}elsif(/HINA_OK/){
			if(/[^\(]<a\s+href=\"?(.+?)\"?>(?!.{1,10}\()/i){
				$url = $1;
			}elsif(/\"?(http\:\/\/.+?)\"?/i){
				$url = $1;
			}

			# hina.txtȼͥپФ
			my $pri;
			$pri = $1 if(/\s?\[(\d*?)\]\s?\-\->/i);

			# URLΥߤ
			$url =~ s/[\?&]\d+//;
			push(@remlist, $url) unless(grep(/\Q$url\E/, @remlist));

			# Ф
			$time = $Times->timeconv($_, $remlag);

			if($pri eq "0"){
				$lmd = $nm::now - $nm::expiresCount + (60 * 30 * 2);
			}elsif($pri eq "1"){
				$lmd = $nm::now - $nm::expiresCount + (60 * 30);
			}else{
				$lmd = $nm::now - $nm::expiresCount + 60;
			}

			$ret = &set_info($rem, $url, $time, $lmd, 0, $remlag, "", "", $rem);
			($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = undef;

		# ¾URLȻ郎ƱԤɽƤ
		}elsif(/\d+:\d+/){
			if(m%href=\"(.+?)\">%i){
				$url = $1;

				# URLθΥߤ
				$url =~ s/[\?&]\d+//;
				push(@remlist, $url) unless(grep(/\Q$url\E/, @remlist));

				# Ф
				$time = $Times->timeconv($_, $remlag);

				$lmd = $nm::now - $nm::expiresCount + 60;

				$ret = &set_info($rem, $url, $time, $lmd, 0, $remlag, "", "", $rem);
				($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = undef;
			}
		}
	}
	return $ret;
}


##
# Ȥľ˻
sub site_access($;$){
	my $mos = shift;
	my $oldlastmod = shift;
	my $moss = &nm::urlkey($mos);
	my ($target, $length, $modtime, $match, $author, $title);
	my @req;
	my ($sel, $remote);

	$target = $nm::info_ref->{$moss}->{'VURL'};
	$target = $mos unless($target);

	$match = $nm::info_ref->{$moss}->{'KEY'};

print "(target file/server: $target)\012";

	DETECT:{
		if($target =~ m%http://%i){
			if($match eq ""){
print "  get information from HEAD request\012";
				@req = $HTTPs->http_access($target, 'HEAD', $oldlastmod, $nm::UserAgent, $nm::cf::referer, $nm::cf::http_proxy);

				if($req[0] =~ /200/){
					foreach my $q (@req){
						$q = &nm::eucconv($q);

						if($q =~ /last-modified: (.*)/i){
							$modtime = $Times->timeconv($1, $nm::info_ref->{$mos}->{'LAG'});
						}
						if($q =~ /Content-Length: (.*)/i){
							$length = $1;
						}
						if($q =~ /Author: (.*)/i){
							$author = $1;
						}
						if($q =~ /Title: (.*)/i){
							$title = $1;
						}
					}

				}elsif($req[0] =~ /302/){
print "  ".$req[0]."\012";
					foreach my $q (@req){
						if($q =~ /Location: (.*)(\015|\012)/i){
							$target = $1;
							$modtime = "";
print "    302 moved. location: $target retry\012";
							goto DETECT;
						}
					}

				}else{
print "  ".$req[0]."\012\012";
					return undef;

				}

				if($modtime ne ""){
#print "  $modtime\012";
					&set_info("HEAD", $mos, $modtime, $nm::now, $length, $nm::info_ref->{$moss}->{'LAG'}, $title, $author, $nm::cf::referer);
print "\012";
					return undef;

				}else{
print "    get information from HEAD request failed\012";
				}
			}

			@req = ();

			if($modtime eq ""){
print "  GET document\012";
				@req = $HTTPs->http_access($target, 'GET', $oldlastmod, $nm::UserAgent, $nm::cf::referer, $nm::cf::http_proxy);

				if($req[0] =~ /^\d\d\d/){
print "  ".$req[0]."\012\012";
					return undef;

				}else{
#					if($match eq "!analysis"){
print "    get information from document analysis\012";
						# LIRS, DI,hina.txt
						if(&analysis('GET', $nm::info_ref->{$moss}->{'LAG'}, \@req)){
print "\012";
							return undef;
						}
#					}

print "    get information from document\012";
					# ɽ
					my @s;
					my $tmp = join('', @req);
					if($tmp =~ /Content-Length: (.*?)/i){
						$length = $1;
					}
					$length = length($tmp) if($length eq "");

					$tmp = &nm::eucconv($tmp);
					$tmp =~ s/\015\012/\012/og;
					$tmp =~ s/\015/\012/og;

					if($tmp =~ /meta.*?name="author".*?content="(.*?)"/i){
						$author = $1;
					}
					if($tmp =~ /<title.*?>(.+?)<\/title.*?>/i){
						$title = $1;
					}

					if($match){
						$tmp =~ s/$match/push(@s, $&) && $&/eg;
						$tmp =~ s/$match.*\012/push(@s, $&) && $&/eg;
						$tmp =~ s/\012.*$match/push(@s, $&) && $&/eg;
						$tmp =~ s/.*\012.*$match.*\012.*\012/push(@s, $&) && $&/eg;
					}

					$tmp =~ s/modified.*/push(@s, $&) && $&/ieg;
					$tmp =~ s/update.*/push(@s, $&) && $&/ieg;
					$tmp =~ s/.*/push(@s, $&) && $&/eg;

					$tmp =~ s/.*modified.*/push(@s, $&) && $&/ieg;
					$tmp =~ s/.*update.*/push(@s, $&) && $&/ieg;
					$tmp =~ s/.*.*/push(@s, $&) && $&/eg;
#					$tmp =~ s/.*ǽ.*/push(@s, $&) && $&/eg;

					$tmp =~ s/.*\012.*modified.*\012.*/push(@s, $&) && $&/ieg;
					$tmp =~ s/.*\012.*update.*\012.*/push(@s, $&) && $&/ieg;
					$tmp =~ s/.*\012.*.*\012.*/push(@s, $&) && $&/eg;
					$tmp =~ s/\$Id:.*\012.*\012/push(@s, $&) && $&/eg;
#					$tmp =~ s/.*\012.*ǽ.*\012.*/push(@s, $&) && $&/eg;

					for(@s){
						$modtime = $Times->timeconv($_, $nm::info_ref->{$moss}->{'LAG'});
						last if($modtime ne "");
					}
					@s = ();

#					unless($modtime){
#						$modtime = $Times->timeconv("$tmp", $nm::info_ref->{$moss}->{'LAG'});
#					}

					if($modtime ne ""){
						# 
#print "  $modtime\012";
						&set_info("GET", $mos, $modtime, $nm::now, $length, $nm::info_ref->{$moss}->{'LAG'}, $title, $author, $nm::cf::referer);
print "\012";

					}else{
print "    get information from GET request failed\012";

print "  get information from Content-Length\012";
						if($length ne ""){
							if($nm::info_ref->{$moss}->{'LENGTH'} <= "0"){
print "  add document length information\012";
print "  length:$length\012";
								&set_info("LENGTH", $mos, "0", $nm::now, $length, $nm::info_ref->{$moss}->{'LAG'}, $title, $author, $nm::cf::referer);
print "\012";

							}elsif(abs($nm::info_ref->{$moss}->{'LENGTH'} - $length) > 64){
print "  get information from document length\012";
print "  length:".$nm::info_ref->{$moss}->{'LENGTH'}." -> $length\012";
								&set_info("LENGTH", $mos, ($nm::now - 600), $nm::now, $length, $nm::info_ref->{$moss}->{'LAG'}, $title, $author, $nm::cf::referer);
print "\012";

							}else{
print "  not changed this site\012";
print "  length:".$nm::info_ref->{$moss}->{'LENGTH'}." -> $length\012";
								&set_info("LENGTH", $mos, "0", $nm::now, $length, $nm::info_ref->{$moss}->{'LAG'}, $title, $author, 0);
print "\012";
							}

						}
					}
				}

			}
		}elsif($target =~ m%^file://(.*)%i){
#			if($match eq "!analysis"){
print "  get information from FILE analysis\012";
				# LIRS, DI,hina.txt
				@req = $Files->read_file($1, $nm::cf::os);
				if(&analysis('FILE', $nm::info_ref->{$moss}->{'LAG'}, \@req)){
print "\012";
					return undef;
				}
#			}

print "  get information from FILE time stamp\012";
			$modtime = $Files->file_time($1);
			$length = $Files->file_size($1);
			&set_info("FILE", $mos, $modtime, $nm::now, $length, $nm::info_ref->{$moss}->{'LAG'}, "", "", $nm::cf::referer);
print "\012";
#print "  $modtime\012";
		}
	}#DETECT end

}



1;
