package htmlrender;

require 5.004;
use strict;

use File::Copy;
use nm;
use nm::files;
use nm::times;
use nm::https;
use LIRS;

$nm::htmlrender::version = q(1.00);

my $Files = new nm::files;
my $Times = new nm::times;
my $HTTPs = new nm::https;
my $LIRS = new LIRS;


sub htmlrender{
	my $conf = shift;

print "\012\"htmlrender::htmlrender\" start\012";

	$nm::now = time;
	$nm::remote_ref = {};
	@nm::urllist = ();

	$nm::cf::html::rem = undef;
	$nm::cf::html::html = {};
	$nm::cf::html::template = undef;

print "read cfg file: $nm::cf::bin$conf\012";
	require qq($nm::cf::bin$conf);
	delete($INC{qq($nm::cf::bin$conf)});

	my $info_ref ={};
	my $localTime = ($Times->tz2tzlag($nm::cf::localTimeZone))[1];

	# cfgե(ե)ɤ߹
print "\012read remote cfg file.\012";
	&nm::readcfg("null", $nm::cf::html::rem);

	# HTMLեؤν񤭽Ф
print "\012output HTML file(s)\012";
	while(my ($target, $src) = each(%nm::cf::html::html)){
print "  output HTML file: $nm::cf::ext$target\012";
		open(HTML, ">$nm::cf::ext$target");
		open(BASE, "$nm::cf::bin$src");
		flock(HTML, 2) if($nm::cf::os eq 'unix');
		flock(BASE, 2) if($nm::cf::os eq 'unix');

		while(my $qr = <BASE>){
			$qr =~ s/\015\012/\012/g;
			$qr =~ s/\015/\012/g;
			if($qr =~ /<!--==.*?==-->(\015|\012)*$/){
#				$qr =~ s/<!--==.*?==-->//ig;
#				print HTML $qr;
				$qr = undef;

			}elsif($qr =~ /^<!--NATSUMICAN_OUTPUT\:(.+?)-->(\015|\012)*$/){
				my $of = $1;
				$of =~ s/%ext%/$nm::cf::ext/g;
				$of =~ s/%base%/$nm::cf::base/g;
print "    read LIRS file $of\012";
				if($of =~ m%^http://%){
					my $tmp_file = ($HTTPs->parseURL($of))[3];
					$tmp_file =~ s%.*/([^/]+?)$%$1%;

					my @tmp = $HTTPs->http_access($of, 'GET', "0", $nm::UserAgent, $nm::cf::referer, $nm::cf::http_proxy);

					if($tmp[0] =~ /^\d\d\d$/ || $tmp[0] eq ""){

					}else{
						$Files->write_file("$nm::cf::tmp$tmp_file.$$", join('', @tmp), $nm::cf::os);
						move("$nm::cf::tmp$tmp_file.$$", "$nm::cf::tmp$tmp_file");
						if($tmp_file =~ /.*\.gz$/i){
							$LIRS->extractLIRS($nm::cf::gzip, "$nm::cf::tmp$tmp_file");
							$tmp_file =~ s/(.*)\.gz$/$1/i;
						}
						@tmp = ();
					}

					$of = "$nm::cf::tmp$tmp_file";
				}

				if(-e "$of"){
					open(SRC, "$of");
					flock(SRC, 2) if($nm::cf::os eq 'unix');
					while(<SRC>){
						$_ = &nm::eucconv($_);
						unless(/^#/){
							if(/^LIRS.*/){
								my $output = &lirs2html($_);
								print HTML $output;
							}
						}
					}
					close(SRC);
				}else{
print "    Can't read LIRS file $of\012";
				}

				$qr = undef;

			}elsif($qr =~ /^<!--NATSUMICAN_SORT_OUTPUT\:(\d*)\:(.+?)-->(\015|\012)*$/){
				my $ct = $1;
				my $of = $2;
				$of =~ s/ //g;
				$of =~ s/%ext%/$nm::cf::ext/g;
				$of =~ s/%base%/$nm::cf::base/g;
print "    read LIRS file $of\012";
				if($of =~ m%^http://%){
					my $tmp_file = ($HTTPs->parseURL($of))[3];
					$tmp_file =~ s%.*/([^/]+?)$%$1%;

					my @tmp = $HTTPs->http_access($of, 'GET', "0", $nm::UserAgent, $nm::cf::referer, $nm::cf::http_proxy);

					if($tmp[0] =~ /^\d\d\d$/ || $tmp[0] eq ""){

					}else{
						$Files->write_file("$nm::cf::tmp$tmp_file.$$", join('', @tmp), $nm::cf::os);
						move("$nm::cf::tmp$tmp_file.$$", "$nm::cf::tmp$tmp_file");
						if($tmp_file =~ /.*\.gz$/i){
							$LIRS->extractLIRS($nm::cf::gzip, "$nm::cf::tmp$tmp_file");
							$tmp_file =~ s/(.*)\.gz$/$1/i;
						}
						@tmp = ();
					}

					$of = "$nm::cf::tmp$tmp_file";
				}

				if(-e "$of"){
					open(SRC, "$of");
					flock(SRC, 2) if($nm::cf::os eq 'unix');
					while(<SRC>){
						$_ = &nm::eucconv($_);
						unless(/^#/){
							if(/^LIRS.*/){
								my ($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = $LIRS->tolist($_);
								$optional =~ s/\\,/%2c/g;
								my ($vurl, $key, $option, $etc, $refer) = split(",", $optional);
								$vurl =~ s/%2c/\,/ig;
								$key =~ s/%2c/\,/ig;
								$option =~ s/%2c/\,/ig;
								$etc =~ s/%2c/\,/ig;

								if($url){
									$info_ref->{$url}->{'LASTMOD'} = $time;
									$info_ref->{$url}->{'LMD'} = $lmd;
									$info_ref->{$url}->{'LAG'} = $lag;
									$info_ref->{$url}->{'LENGTH'} = $length;
									$info_ref->{$url}->{'TITLE'} = $title;
									$info_ref->{$url}->{'AUTHOR'} = $author;
									$info_ref->{$url}->{'REMOTE'} = $remote;
									$info_ref->{$url}->{'VURL'} = $vurl;
									$info_ref->{$url}->{'KEY'} = $key;
									$info_ref->{$url}->{'OPTION'} = $option;
									$info_ref->{$url}->{'ETC'} = $etc;
									$info_ref->{$url}->{'REFER'} = $refer;
								}
							}
						}
					}
					close(SRC);

					my $pt = 0;
					foreach my $i (sort{$info_ref->{$b}->{'LASTMOD'} <=> $info_ref->{$a}->{'LASTMOD'}} keys %$info_ref){
						if($ct){
							$pt++;
							last if($pt > $ct);
						}
						my ($time, $lmd, $lag, $length, $url, $title, $author, $optional, $remote, $vurl, $key, $option, $etc, $refer) = "";
						$time = $info_ref->{$i}->{'LASTMOD'};
						$lmd = $info_ref->{$i}->{'LMD'};
						$lag = $info_ref->{$i}->{'LAG'};
						$length = $info_ref->{$i}->{'LENGTH'};
						$title = $info_ref->{$i}->{'TITLE'};
						$author = $info_ref->{$i}->{'AUTHOR'};
						$remote = $info_ref->{$i}->{'REMOTE'};
						$vurl = $info_ref->{$i}->{'VURL'};
						$key = $info_ref->{$i}->{'KEY'};
						$option = $info_ref->{$i}->{'OPTION'};
						$etc = $info_ref->{$i}->{'ETC'};
						$refer = $info_ref->{$i}->{'REFER'};

						my $s = "$vurl,$key,$option,$etc,$refer";
						my $r = $LIRS->toLIRS($time, $lmd, $lag, $length, $i, $title, $author, $remote, $s);

						my $output = &lirs2html($r);
						print HTML $output;
					}

					$info_ref ={};

				}else{
print "    Can't read LIRS file $of\012";
				}

				$qr = undef;

			}elsif($qr =~ /<!--NATSUMICAN_REMOTESERVER-->/){
				my $ret;
				foreach my $u (keys %$nm::remote_ref){
					my $m_name = $nm::remote_ref->{$u}->{'M_NAME'};
					my $name = $nm::remote_ref->{$u}->{'NAME'};
					if($m_name && $name){
						$ret .= ", " if($ret);
						$ret .= $m_name.' : '.$name;
#						$ret .= $m_name.' : '.'<A HREF="'.$nm::remote_ref->{$u}->{'URL'}.'">'.$name.'</A>';
					}
				}
				$ret = 'remote data not found' if(!$ret);
				$qr =~ s/<!--NATSUMICAN_REMOTESERVER-->/$ret/g;
				print HTML $qr;
				$qr = undef;

			}elsif($qr =~ /<!--NATSUMICAN_MODIFIED-->/){
				my $x = $Times->showdate(($nm::now + $localTime), "%ee%, %DD% %nn% %YYYY% %HH%:%TT%:%SS%");
				my $timezone = ($Times->tz2tzlag($localTime))[0];
				$x .= " $timezone";
				$qr =~ s/<!--NATSUMICAN_MODIFIED-->/$x/g;

			}
			$qr =~ s/<!--NATSUMICAN_VERSION-->/$nm::version/g;
			print HTML $qr;
			$qr = undef;
		}
		close(BASE);
		close(HTML);
print "\012";
	}

	($nm::remote_ref, @nm::urllist) = undef;

print "\"htmlrender::htmlrender\" end\012";
}


sub except{
	my $conf = shift;

print "\012\"htmlrender::except\" start\012";

	@nm::cf::ex::html = ();

print "read cfg file: $nm::cf::bin$conf\012";
	require qq($nm::cf::bin$conf);
	delete($INC{qq($nm::cf::bin$conf)});

	foreach my $htmlfile (@nm::cf::ex::html){
		open(HTML, "$nm::cf::ext$htmlfile");
		open(TMP, ">${nm::cf::tmp}$htmlfile.$$");
		flock(HTML, 2) if($nm::cf::os eq 'unix');
		flock(TMP, 2) if($nm::cf::os eq 'unix');

		while(<HTML>){
			s/\?\d{8}">/">/g;
			s/<A HREF=".*?">([a-z\*])<\/A>/$1/g;
			print TMP;
		}

		close(TMP);
		close(HTML);

		move("${nm::cf::tmp}$htmlfile.$$", "$nm::cf::ext$htmlfile");
	}

print "\"htmlrender::except\" end\012";
}


sub lirs2html{
	my $lirs = shift;
	my ($time, $lmd, $lag, $length, $url, $title, $author, $remsrc, $optional) = $LIRS->tolist($lirs);

	$optional =~ s/\\,/%2c/g;
	my ($vurl, $key, $option, $etc, $refer) = split(",", $optional);
	$vurl =~ s/%2c/\,/ig;
	$key =~ s/%2c/\,/ig;
	$option =~ s/%2c/\,/ig;
	$etc =~ s/%2c/\,/ig;

	if($url){
		my ($remote, $outdat);

		if($refer eq "HEAD"){
			$remote = "H";
		}elsif($refer eq "GET"){
			$remote = "G";
		}elsif($refer eq "FILE"){
			$remote = "F";
		}elsif($refer eq "CACHE"){
			$remote = "C";
		}elsif($refer eq "LENGTH"){
			$remote = "L";
		}elsif($refer eq "PUSH"){
			$remote = "P";
		}else{
			foreach my $v (keys %$nm::remote_ref){
				if($nm::remote_ref->{$v}->{'URL'} eq $refer){
					$remote = $nm::remote_ref->{$v}->{'M_NAME'};
					last;
				}
			}
			if($remote eq ""){
				$remote = "0";
			}
		}
		$remsrc = "" if($remsrc eq "0");

		if($time <= 0){
			$outdat = $Times->showdate("null", "$nm::cf::html::template");
			$option = "";
		}else{
			my $lags = ($Times->tz2tzlag($lag))[1];
			$outdat = $Times->showdate(($time + $lags), "$nm::cf::html::template");
		}
		my $timezone = ($Times->tz2tzlag($lag))[0];
		$title = "TITLE UNKNOWN" if($title eq "0");
#		$title = undef if($title eq "0");
#		$author = "unknown" if($author eq "0");
		$author = undef if($author eq "0");

		$outdat =~ s/%title%/$title/g;
		if($vurl){
			$outdat =~ s/%vurl%/$vurl/g;
		}else{
			$outdat =~ s/%vurl%/$url/g;
		}
#		$outdat =~ s/%url%/$url$option/g;
		$outdat =~ s/%url%/$url/g;
		$outdat =~ s/%option%/$option/g;
		$outdat =~ s/%author%/$author/g;
		$outdat =~ s/%etc%/&nm::cf::html::etcscript("$etc")/eg;
		$outdat =~ s/%remote%/$remote/g;
		$outdat =~ s/%remsrc%/$remsrc/g;
		$outdat =~ s/%tz%/$timezone/g;

		$outdat =~ s/\\,/,/g;
		$outdat =~ s/\\n/\012/g;
		$outdat =~ s/\\t/\t/g;

		return $outdat;
	}
	return undef;
}



1;

