package nm;

require 5.004;
use strict;

use File::Copy;

$nm::nm::version = q(1.00);


sub ver{
	return $nm::nm::version;
}



sub init{
print "\012";
	# 
	$SIG{'INT'} = $SIG{'BUS'} = $SIG{'HUP'} = $SIG{'QUIT'} = $SIG{'TERM'} = $SIG{'ALRM'} = 'end';
	if($nm::cf::os eq "unix"){
		if($nm::cf::priority > 1){
			setpriority(0, 0, getpriority(0, 0) + $nm::cf::priority);
print "process priority: $nm::cf::priority\012";
		}
		alarm(1200);
	}

	&setver();
print "$nm::UserAgent start\012";

	$nm::expiresCount = q(23400);
	$nm::now = time;
	$nm::info_ref ={};
	$nm::remote_ref = {};
	@nm::urllist = ();

	use nm::files;
	use nm::times;

	my $Files = new nm::files;
	my $Times = new nm::times;

	if($Files->ver < 1){
print "ERROR!: Files library \"nm::files\" is old.\012";
		exit(1);
	}
	if($Times->ver < 1){
print "ERROR!: Times library \"nm::times\" is old.\012";
		exit(1);
	}

	# ǥ쥯ȥư
	chdir $nm::cf::bin || die "Can't find directory $nm::cf::bin\012";

	# Ť⡼ȾTMPǥ쥯ȥ򤭤줤ˤ
	my @files = $Files->alldirs("$nm::cf::tmp");
	foreach my $g (@files){
		unlink("$g") if(($Files->file_time("$g") + (60 * 60 * 2)) < $nm::now);
	}

	# lockեκȹϻեǤФ
	if(-e "$nm::cf::ext".'natsumican.lock'){
		if($Files->lfile_time("$nm::cf::ext".'natsumican.lock') + (60 * 60 * 3) < $nm::now){
			# .lockե뤬Ƥ3ַвᤷƤ顢.lockե롣
			unlink("$nm::cf::ext".'natsumican.lock') || print STDERR "natsumican.lock: $!\012";
print "natsumican.lock: lock file is older, delete lock file, and recovery.\012";

		}else{
print "natsu-mican $nm::version: lock-file exists.\012";
			exit(0);
		}
	}
	open(TMP, ">$nm::cf::ext".'natsumican.lock') || die "Can't create lock file\012";
	close(TMP);
print "lock set\012";
	open(TMP, ">$nm::cf::tmp".'natsumican.start') || die "Can't create start file\012";
	close(TMP);

	if(eval 'require NKF'){
		$nm::cf::conv = q(NKF);
	}else{
		if(eval 'require Jcode'){
			$nm::cf::conv = q(Jcode);
		}else{
			if(eval 'require "jcode.pl"'){
				$nm::cf::conv = q(jcodepl);
			}else{
				$nm::cf::conv = q(error);
			}
		}
	}
	if($nm::cf::conv eq 'error'){
print "\012ERROR!: Can't find Kanji code converter.\012";
		exit(1);
	}else{
print "\012Kanji code converter found: $nm::cf::conv\012";
	}
}



# λؿ
sub end{
	# lockեκ
	unlink("$nm::cf::ext".'natsumican.lock') || print STDERR "natsumican.lock: $!\012";
	print "\012unlock\012";

	exit(0);
}



sub initinfo{
	# 
	&setver();

	$nm::now = time;
}



sub setver(){
	$nm::version = '3.1b';
	$nm::modified = '20010312';
	$nm::version .= "(".$nm::modified.")";
	$nm::UserAgent = 'NATSU-MICAN/';
	$nm::UserAgent .= $nm::version;

	$0 = $nm::UserAgent;
}



##
# cfgե(ե)ɤ߹
sub readcfg{
	my $cfgref = shift;
	my $rem = shift;

	my $Files = new nm::files;
	my $Times = new nm::times;
	my $HTTPs = new nm::https;
	my $LIRS = new LIRS;

	my @cfgset;
	my @cfgdat;

	if($cfgref ne "null"){
		@cfgset = @$cfgref;

		# оݥ
		foreach my $cfg (@cfgset){
print "read cfg: $cfg\012";
			if($cfg){
				if($cfg =~ m%^http://%){
					my $cfg_file = ($HTTPs->parseURL($cfg))[3];
					$cfg_file =~ s%.*/([^/]+?)$%$1%;

					my $lmdtime;
					if(-e "$nm::cf::bin$cfg"){
						$lmdtime = $Times->file_time("$nm::cf::bin$cfg_file");
					}else{
						$lmdtime = 0;
					}

					@cfgdat = $HTTPs->http_access($cfg, 'GET', $lmdtime, $nm::cf::http_proxy);

					if($cfgdat[0] =~ /^\d\d\d$/ || $cfgdat[0] eq ""){
						@cfgdat = ();
						@cfgdat = $Files->read_file("$nm::cf::bin$cfg_file", $nm::cf::os);
					}else{
						my $out = join('', @cfgdat);
						$out =~ s%,file://.+?,%,,%g;
						$Files->write_file("$nm::cf::tmp$cfg_file.$$", $out, $nm::cf::os);
						move("$nm::cf::tmp$cfg_file.$$", "$nm::cf::bin$cfg_file");
						if($cfg_file =~ /.*\.gz$/i){
							$LIRS->extractLIRS($nm::cf::gzip, "$nm::cf::bin$cfg_file");
							@cfgdat = ();
							$cfg =~ s/(.*)\.gz$/$1/i;
							@cfgdat = $Files->read_file("$nm::cf::bin$cfg_file", $nm::cf::os);
						}
					}

				}else{
					@cfgdat = $Files->read_file("$nm::cf::bin$cfg", $nm::cf::os);
				}
				for(@cfgdat){
					$_ = &eucconv($_);
					unless(/^#/){
						if(/^LIRS.*/){
							my ($time, $lmd, $lag, $length, $url, $title, $author, $remote, $optional) = $LIRS->tolist($_);
							$optional =~ s/\\/%5c/g;
							$optional =~ s/%5c%5c/%rr/g;
							$optional =~ s/%5c,/%2c/g;
							$optional =~ s/%rr/\\\\/g;
							$optional =~ s/%5c/\\/g;
							my ($vurl, $key, $option, $etc) = split(",", $optional);
							$vurl =~ s/%2c/,/ig;
							$key =~ s/%2c/,/ig;
							$option =~ s/%2c/,/ig;
							$etc =~ s/%2c/,/ig;

							if($url){
								$url = $Times->showdate(($nm::now + $nm::cf::localTimeZone - (60 * 60 * 12)), $url) if($url =~ /%.+%/);

								$url =~ s/%7e/~/io;
								push(@nm::urllist, $url);

								my $keyurl = &urlkey($url);

								if($vurl){
									$vurl = $Times->showdate(($nm::now + $nm::cf::localTimeZone - (60 * 60 * 12)), $vurl) if($vurl =~ /%.+%/);

									$vurl =~ s/%7e/~/io;
									if($vurl !~ m%^file://%i){
										push(@nm::urllist, $vurl);
										my $keyvurl = &urlkey($vurl);
										$nm::info_ref->{$keyvurl}->{'ALIAS'} = $url;
									}
								}

								$nm::info_ref->{$keyurl}->{'LASTMOD'} = 0;
								$nm::info_ref->{$keyurl}->{'LAG'} = $lag;
								$nm::info_ref->{$keyurl}->{'TITLE'} = $title;
								$nm::info_ref->{$keyurl}->{'AUTHOR'} = $author;
								$nm::info_ref->{$keyurl}->{'VURL'} = $vurl;
								$nm::info_ref->{$keyurl}->{'KEY'} = $key;
								$nm::info_ref->{$keyurl}->{'OPTION'} = $option;
								$nm::info_ref->{$keyurl}->{'ETC'} = $etc;

							}
						}
					}
				}
			}else{
				last;
			}
		}
	}

	if($rem){
		if($cfgset[0] ne $rem){

			# ⡼ȥƥ
print "read remote cfg file: $rem\012";
			@cfgdat = ();
			if($rem =~ m%^http://%){
				my $cfg_file = ($HTTPs->parseURL($rem))[3];
				$cfg_file =~ s%.*/([^/]+?)$%$1%;

				my $lmdtime;
				if(-e "$nm::cf::bin$cfg_file"){
					$lmdtime = $Files->file_time("$nm::cf::bin$cfg_file");
				}else{
					$lmdtime = 0;
				}

				@cfgdat = $HTTPs->http_access($rem, 'GET', $lmdtime, $nm::cf::http_proxy);

				if($cfgdat[0] =~ /^\d\d\d$/ || $cfgdat[0] eq ""){
					@cfgdat = ();
					@cfgdat = $Files->read_file("$nm::cf::bin$cfg_file", $nm::cf::os);
				}else{
					my $out = join('', @cfgdat);
					$out =~ s%,file://.+?,%,,%gm;
					$Files->write_file("$nm::cf::tmp$cfg_file.$$", $out, $nm::cf::os);
					move("$nm::cf::tmp$cfg_file.$$", "$nm::cf::bin$cfg_file");
					if($cfg_file =~ /.*\.gz$/i){
						$LIRS->extractLIRS($nm::cf::gzip, "$nm::cf::bin$cfg_file");
						@cfgdat = ();
						$cfg_file =~ s/(.*)\.gz$/$1/i;
						@cfgdat = $Files->read_file("$nm::cf::bin$cfg_file", $nm::cf::os);
					}
				}
			}else{
				@cfgdat = $Files->read_file("$nm::cf::bin$rem", $nm::cf::os);
			}
		}else{
print "not read remote cfg file: \@nm::cf::cfg equal \$nm::cf::rem\012";
		}
		for(@cfgdat){
			$_ = &eucconv($_);
			unless(/^#/){
				if(/^REMOTE.*/){
					chomp;
					s/\\/%5c/g;
					s/%5c%5c/%rr/g;
					s/%5c,/%2c/g;
					s/%rr/\\\\/g;
					s/%5c/\\/g;
					my ($nul, $m_name, $name, $url, $filename, $get_url, $lag, $nul) = split(",", $_, 8);
					$url =~ s/%7e/~/io;

					$m_name =~ s/%2c/,/ig;
					$name =~ s/%2c/,/ig;
					$url =~ s/%2c/,/ig;
					$filename =~ s/%2c/,/ig;
					$get_url =~ s/%2c/,/ig;

					$nm::remote_ref->{$get_url}->{'LASTMOD'} = 0;
					$nm::remote_ref->{$get_url}->{'M_NAME'} = $m_name;
					$nm::remote_ref->{$get_url}->{'NAME'} = $name;
					$nm::remote_ref->{$get_url}->{'URL'} = $url;
					$nm::remote_ref->{$get_url}->{'FILE'} = $filename;
					$nm::remote_ref->{$get_url}->{'GET_URL'} = $get_url;
					$nm::remote_ref->{$get_url}->{'LAG'} = $lag;
				}
			}
		}
	}

	($Files, $Times, $HTTPs, $LIRS, @cfgset, @cfgdat) = undef;
}


sub eucconv{
	my $str = shift;

	if($nm::cf::conv eq 'NKF'){
		$str = &NKF::nkf('-e', $str);

	}elsif($nm::cf::conv eq 'Jcode'){
		$str = Jcode->new($str)->h2z->euc;

	}elsif($nm::cf::conv eq 'jcodepl'){
		&jcode::convert(\$str, 'euc');
	}

	$str;
}


sub urlkey{
	my $url = shift;

#print "$url -> ";

	my $protocol = 'http';
	my $port = 80;
	my $server;
	my $userfile;

	if($url =~ m%^(\w+://)%o){
		$url =~ s%^((\w+)://)%%;
		$protocol = $2;
	}
	unless($protocol eq 'file'){
		$url =~ s%^([^/:]+)%%;
		$server = $1;
		if($url =~ m%^(:(\d+))%o){
			$url =~ s%^(:(\d+))%%o;
			$port = $2;
		}
	}
	$userfile = $url;
	$userfile = "/$userfile" unless($userfile =~ m%^/%);

	if($port eq '80'){
		$port = undef;
	}else{
		$port = ':'.$port;
	}
#	$server =~ tr/A-Z/a-z/;
	my $ret = $protocol.'://'."\L$server\E".$port.$userfile;

#print "$ret\n";

	return $ret;

}

1;
