# ֤ʤĤߤץ饤֥https.pm
# "NATSU-MICAN" Copyright (C) 1998-2000 hiya All Rights Reserved.

# 
package nm::https;
require 5.004;
use strict;
use Time::Local;
use IO::Socket;
use IO::Select;

use nm::times;

$nm::https::version = q(1.00);

my $Times = new nm::times;

## new
# 󥹥󥹤롣
sub new{
	my $pkg = shift;
	my $self = bless {}, $pkg;
	return $self;
}


sub ver{
	return $nm::https::version;
}


##
# parseURL($url)
sub parseURL{
	my $self = shift;
	$_ = shift;
	my $protocol = 'http';
	my $port = 80;
	my $server;
	my $userfile;

	if(m%^(\w+://)%o){
		s%^((\w+)://)%%;
		$protocol = $2;
	}

	unless($protocol eq 'file'){
		s%^([^/:]+)%%;
		$server = $1;
		if ( m%^(:(\d+))%o ){
			s%^(:(\d+))%%o;
			$port = $2;
		}
	}

	$userfile = $_;
	$userfile = "/$userfile" unless($userfile =~ m%^/%);
	return($protocol, $server, $port, $userfile);
}


##
# åȥȤեHTTP(HEAD/GET)
# ֤ͤϡHEADξƤΥإåGETξ200äƤƥȤ/顼(̵Ѵ)200ʳΤȤϤֹ֤
sub http_access{
	my $self = shift;
	my ($TARGET, $REQ, $LMDTIME, $USERAGENT, $REFERER, $PROXYSRV) = @_;

	my ($qur, $host, $port, $sel, $remote, $http_opt);
	my (@RET, @ready);

	my $connect_timeout = 15;
	my $read_timeout = 20;

	my @PROXY = $self->parseURL($PROXYSRV) if($PROXYSRV);
	my @URL = $self->parseURL($TARGET);

	if($URL[0] eq 'http'){
		$http_opt = $REQ." ";
		if($REQ eq 'HEAD'){
			if($PROXYSRV){
				$host = $PROXY[1];
				$port = $PROXY[2];
				$http_opt .= $TARGET." HTTP/1.1\015\012";
				$http_opt .= "Host: ".$PROXY[1]."\015\012";
			}else{
				$host = $URL[1];
				$port = $URL[2];
				$http_opt .= $URL[3]." HTTP/1.1\015\012";
				$http_opt .= "Host: ".$URL[1]."\015\012";
			}

		}elsif($REQ eq 'GET'){
			if($PROXYSRV){
				$host = $PROXY[1];
				$port = $PROXY[2];
				$http_opt .= $TARGET." HTTP/1.0\015\012";
				$http_opt .= "Host: " .$PROXY[1]."\015\012";
			}else{
				$host = $URL[1];
				$port = $URL[2];
				$http_opt .= $URL[3]." HTTP/1.0\015\012";
				$http_opt .= "Host: ".$URL[1]."\015\012";
			}
		}else{
			return 0;
		}

		if($LMDTIME){
			$http_opt .= "If-modified-since: ";
			$http_opt .= $Times->showdate($LMDTIME, "%ee%, %DD% %nn% %YYYY% %HH%:%TT%:%SS% GMT");
			$http_opt .= "\015\012";
		}
		$http_opt .= "User-Agent: ".$USERAGENT."\015\012";
		$http_opt .= "Referer: ".$REFERER."\015\012";
		$http_opt .= "Connection: close\015\012";

		$sel = new IO::Select();
		$remote = IO::Socket::INET->new(Proto => "tcp", PeerAddr => $host, PeerPort => $port, Timeout => $connect_timeout);
		if($remote){
			$sel->add($remote);
			$remote->autoflush(1);
			print $remote $http_opt."\015\012";

			@ready = $sel->can_read($read_timeout);
			if(@ready){
				foreach my $sock (@ready){
					my $q;
					my $o = 0;

					$qur = <$remote>;

					if($REQ eq 'HEAD'){
						while($q = <$remote>){
							$q =~ s/\015\012/\012/og;
							$q =~ s/\015/\012/og;
							last if($q =~ /^\012$/i);
							push(@RET, $q);
						}

					}elsif($REQ eq 'GET'){
						while($q = <$remote>){
							if($o == 1){
								push(@RET, $q);
							}else{
								$q =~ s/\015\012/\012/og;
								$q =~ s/\015/\012/og;
								$o = 1 if($q =~ /^\012$/i);
							}
						}
					}
					close($remote);
				}

			}else{
				print STDERR "  read timeout ".$TARGET."\012";
				close($remote);
				return '408';
			}

		}else{
			print STDERR "  cannot open ".$TARGET." $!\012";
			return '408';

		}
	}

	if($qur =~ /200/){
		unshift(@RET, $qur) if($REQ eq 'HEAD');
		return wantarray ? @RET : join('', @RET);

	}elsif($qur =~ /^HTTP/){
		if($REQ eq 'HEAD'){
			unshift(@RET, $qur);
			return wantarray ? @RET : join('', @RET);
		}else{
			$qur =~ s%^HTTP/1\.\d (\d\d\d) .*%$1%;
			return $qur;
		}
	}else{
		return '400';
	}
}


1;

