# ֤ʤĤߤץ饤֥times.pm
# "NATSU-MICAN" Copyright (C) 1998-2000 hiya All Rights Reserved.

# 
package nm::times;
require 5.004;
use strict;
use Time::Local;

$nm::times::version = q(1.00);


## new
# 󥹥󥹤롣
sub new{
	my $pkg = shift;
	my $self = bless {}, $pkg;
	return $self;
}


sub ver{
	return $nm::times::version;
}


##
# timeconv(opt1, opt2)
# ͡ʷλɽ顢timeФ
# opt2Ϥλɽλӡɽ˻Ӥ񤫤ƤʤȤΤͭ
sub timeconv{
	my $self = shift;
	$_ = shift;
	my $timezone = 0;
	$timezone = shift;

#print "$_\n";

	$_ =~ s%%:%g;
	$_ =~ s%%/%g;
	$_ =~ s%(|)%\-%g;
	$_ =~ s%%.%g;
	$_ =~ s%%0%g;
	$_ =~ s%%1%g;
	$_ =~ s%%2%g;
	$_ =~ s%%3%g;
	$_ =~ s%%4%g;
	$_ =~ s%%5%g;
	$_ =~ s%%6%g;
	$_ =~ s%%7%g;
	$_ =~ s%%8%g;
	$_ =~ s%%9%g;

	my $time = undef;
	my ($y, $m, $d, $H, $M, $S) = "0";
	my $Z;
	my $this_year = (gmtime($nm::now))[5];
	my $one_hour = 60 * 10;
	my $week = 60 * 60 * 24 * 7;

	# ǯ
	if(m%(\d{1,4})ǯ\s*(\d{1,2})\s*(\d{1,2})%){
		# "1999ǯ1110", "99ǯ 11 10"
		$y = $1; $m = $2 - 1; $d = $3;

	}elsif(m%(\d{1,2})\s*(\d{1,2})%){
		# "1110", "11 10"
		$y = $this_year; $m = $1 - 1; $d = $2;

	}elsif(m%(\d{1,2})\s+(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)\w*\s+(\d{1,4})%i){
		# "06 Nov 1994"
		$y = $3; $m = $self->month2num($2); $d = $1;

	}elsif(m%(\d{1,2})\-(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)\w*\-(\d{1,4})%i){
		# "06-Nov-94", "06-Nov-1994"
		$y = $3; $m = $self->month2num($2); $d = $1;

	}elsif(m%(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)\w*\s+(\d{1,2})\s+(\d\d{1,3})(?!:)%i){
		# "Oct 18 1999"
		$y = $3; $m = $self->month2num($1); $d = $2;

	}elsif(m%(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)\w*\s+(\d{1,2})%i){
		# "Aug 20"
		$y = $this_year; $m = $self->month2num($1); $d = $2;

	}elsif(m%(\d{1,4})/(\d{1,2})/(\d{1,2})%){
		# "1999/11/10", "99/11/10"
		$y = $1; $m = $2 - 1; $d = $3;

	}elsif(m%(\d{1,4})\-(\d{1,2})\-(\d{1,2})%){
		# "1999-11-10", "99-11-10"
		$y = $1; $m = $2 - 1; $d = $3;

	}elsif(m%(\d{1,4})\.(\d{1,2})\.(\d{1,2})%){
		# "1999.11.10", "99.11.10"
		$y = $1; $m = $2 - 1; $d = $3;

	}elsif(m%(\d{1,2})/(\d{1,2})%){
		# "11/10"
		$y = $this_year; $m = $1 - 1; $d = $2;

	}elsif(m%(\d{1,2})\-(\d{1,2})%){
		# "11-10"
		$y = $this_year; $m = $1 - 1; $d = $2;

	}elsif(m%(\d{1,2})\.(\d{1,2})%){
		# "11.10"
		$y = $this_year; $m = $1 - 1; $d = $2;

	}

	# ʬ
	if(m%(\d{1,2})\s*(\d{1,2})ʬ\s*(\d{1,2})%){
		# "2113ʬ35", "21 13ʬ 35"
		$H = $1; $M = $2; $S = 0;

	}elsif(m%(\d{1,2})\s*(\d{1,2})ʬ%){
		# "2113ʬ", "21 13ʬ"
		$H = $1; $M = $2; $S = 0;

	}elsif(m%(\d{1,2}):(\d{1,2}):(\d{1,2}) ([A-Z]{3,4})%){
		# "21:13:35 JST"
		$H = $1; $M = $2; $S = $3; $Z = $4;

	}elsif(m%(\d{1,2}):(\d{1,2}):(\d{1,2})\s*([\+\-]\d\d)%){
		# "21:13:35+09", "21:13:35 +09"
		$H = $1; $M = $2; $S = $3; $Z = $4 * 60 * 60;

	}elsif(m%(\d{1,2}):(\d{1,2}) ([A-Z]{3,4})%){
		# "21:13 JST"
		$H = $1; $M = $2; $S = 0; $Z = $3;

	}elsif(m%(\d{1,2}):(\d{1,2})\s*([\+\-]\d\d)%){
		# "21:13+09", "21:13 +09"
		$H = $1; $M = $2; $S = 0; $Z = $3 * 60 * 60;

	}elsif(m%(\d{1,2}):(\d{1,2}):(\d{1,2})%){
		# "21:13:35"
		$H = $1; $M = $2; $S = $3;

	}elsif(m%(\d{1,2}):(\d{1,2})%){
		# "21:13"
		$H = $1; $M = $2; $S = 0;

	}

	if($Z eq ""){
		# ॾ
		if(m% ([A-Z]{3,4})%){
			$Z = $1;

		}elsif(m%[0-9\s]([\+\-]\d\d)%){
			$Z = $1 * 60 * 60;

		}
	}

	# AM/PM
	if(/pm/i && $H < 13){
		$H += 12;
	}

	# 㳰
	if(m%\w+ (\w+) (\d{1,2}) (\d{1,2}):(\d{1,2}):(\d{1,2}) (\d{1,4}) ([A-Z]{3,4})%io){
		# Sun Apr 9 20:33:40 2000 JST
		$Z = $7; $S = $5; $M = $4; $H = $3; $d = $2; $m = $self->month2num($1); $y = $6;

	}elsif(m%\w+ (\w+) (\d{1,2}) (\d{1,2}):(\d{1,2}):(\d{1,2}) ([A-Z]{3,4}) (\d{1,4})%io){
		# Sun Apr 9 20:33:40 JST 2000
		$Z = $6; $S = $5; $M = $4; $H = $3; $d = $2; $m = $self->month2num($1); $y = $7;

	}elsif(m%\w+ (\w+) (\d{1,2}) (\d{1,2}):(\d{1,2}):(\d{1,2}) (\d{1,4})%io){
		# Sun Nov 6 08:49:37 1994(ANSI C's asctime() format)
		$Z = $timezone; $S = $5; $M = $4; $H = $3; $d = $2; $m = $self->month2num($1); $y = $6;

	}elsif(m%(\d{1,4})ǯ\s*(\d{1,2})\s*(\d{1,2})\s*(\w\w\s*)(\d{1,2}):(\d{1,2})%io){
		# 1999ǯ 11 08 PM 08:40
		$Z = $timezone; $S = 0; $M = $6; $H = $5; $d = $3; $m = $2-1; $y = $1;
		$H += 12 if($4 =~ /pm/i && $H < 12);

	}elsif(m%(\d{1,4})ǯ\s*(\d{1,2})\s*(\d{1,2}).*?(\d{1,2}):(\d{1,2})\s*(\w\w)%io){
		# 2000ǯ 3 31 (),7:32 PM
		$Z = $timezone; $S = 0; $M = $5; $H = $4; $d = $3; $m = $2-1; $y = $1;
		$H += 12 if($6 =~ /pm/i && $H < 12);

	}

	$y -= 1900 if($y >= 1900);
	$y += 100 if($y < 70);

#print "$y/$m/$d $H:$M:$S $Z";

	$Z = ($self->tz2tzlag($Z))[1];
	$Z = $timezone if($Z eq "");

#print " - $Z\n";

	if(((0 <= $S) && ($S <= 59)) && ((0 <= $M) && ($M <= 59)) && ((0 <= $H) && ($H <= 23)) && ((1 <= $d) && ($d <= 31)) && ((0 <= $m) && ($m <= 11)) && (70 <= $y) && ($y <= 137)){
		$time = $self->timeglobal($Z, $S, $M, $H, $d, $m ,$y);
		if($time > $nm::now + $week){
			$time = $self->timeglobal($Z, $S, $M, $H, $d, $m ,$y-1);
		}
	}

	$time;

}


##
# month2num(opt1)
# Ѽɽ֤ͤ(mday);
sub month2num{
	my $self = shift;
	my $mon = shift;

	my %month =	("jan" => "0"
				,"feb" => "1"
				,"mar" => "2"
				,"apr" => "3"
				,"may" => "4"
				,"jun" => "5"
				,"jul" => "6"
				,"aug" => "7"
				,"sep" => "8"
				,"oct" => "9"
				,"nov" => "10"
				,"dec" => "11"
				);

	while(my ($key, $tgt) = each(%month)){
		$mon =~ s/.*$key.*/$tgt/i;
	}

	return $mon;
}


##
# tz2tzlag($tz)
# ॾɽGMTθ줫顢ॾɽGMTȤθξФ
# ॾɽɸϤˤäƤϥޡФ(ۤȤ)
# ʤߤˡޤܤU.S.бƤޤ
sub tz2tzlag{
	my $self = shift;
	my $tz = shift;
	my $time = undef;
	my %stime =	("AST" => "ADT"
				,"AKST" => "AKDT"
				,"PST" => "PDT"
				,"MST" => "MDT"
				,"CST" => "CDT"
				,"EST" => "EDT"
				);
	my %szone =	("HST" => "-36000"
				,"PST" => "-28800"
				,"PDT" => "-25200"
				,"MST" => "-25200"
				,"MDT" => "-21600"
				,"CST" => "-21600"
				,"CDT" => "-18000"
				,"EST" => "-18000"
				,"EDT" => "-14400"
				,"GMT" => "0"
				,"JST" => "32400"
				);
	my %tzone =	("HST" => "-36000"
				,"PST" => "-28800"
				,"MST" => "-25200"
				,"CST" => "-21600"
				,"EST" => "-18000"
				,"GMT" => "0"
				,"JST" => "32400"
				);

	# ͤͿ줿硢ޤͿ줿ͤTZФ
	while(my ($key, $tgt) = each(%tzone)){
		$tz = $key if($tz eq $tgt);
	}

	# TZФ
	$time = $szone{$tz};

	# ˡͻ֤ɤȽꤷơ޻֤ʤTZľ
	# 빽øǡ410δ֤޻֤ȹͤƤޤȤ٤꤬ߤʤɤ͡
	if((gmtime(time - $nm::cf::localTimeZone))[4] >= 3 && (gmtime(time - $nm::cf::localTimeZone))[4] <= 9){
		unless($time){
			while(my ($key, $tgt) = each(%tzone)){
				$tz = $key if(($tz - 3600) eq $tgt);
			}
		}

		foreach my $k (keys %stime){
			if($tz eq $k){
				$tz = $stime{$k};
			}
		}
	}

	# TZФ
	$time = $szone{$tz};

	return $tz, $time;
}


##
# timeglobal($tval, $S, $M, $H, $d, $m, $y)
# ͡ʥॾλ狼顢GMTФ
# $tzϸ⤷ϻӻ
sub timeglobal{
	my $self = shift;
	my $tval = shift;
	my $times = eval(timegm(@_));

	return 0 if($times <= 0);
#	my $tval = ($self->tz2tzlag($tval))[1];

	$times -= $tval;
	return $times;
}


##
# showdate(opt1, opt2)
# 1970ǯ11ÿ(time)顢ͳɽѴ֤֥롼 v2.5
# opt1 Ѵեǡ"now"Ǹ߻򡢤ʳͤꤹȤοͤѴ롣Ѵˤgmtime()ؿѤƤΤǡ륿ʤɤɽȤϤ餫timeglobal()ؿʤɤִƤȡ
# opt2 ֤դηɽʸ
# 	%YYYY%4
# 	%YY%2
# 	%MM%2
# 	%mm%2(0䴰̵)
# 	%DD%2
# 	%dd%2(0䴰̵)
# 	%HH%2
# 	%hh%2(0䴰̵)
# 	%TT%2ʬ
# 	%tt%2ʬ(0䴰̵)
# 	%SS%2
# 	%ss%2(0䴰̵)
# 	%WW%ܸ(ʸ)
# 	%EE%Ѹ(Ĺ)
# 	%ee%Ѹ(û)
# 	%NN%Ѹ(Ĺ)
# 	%nn%Ѹ(û)
# 	%XX%1970ǯ11ÿ
# 	%UU%110νܤ01120ܤ12131βܤ2Ȥ
# 	%uu%110νܤ11120ܤ22131βܤ3Ȥ
# 	%VV%110νܤa1120ܤb2131βܤcȤ
# 	%vv%110νܤA1120ܤB2131βܤCȤ
sub showdate{
	my ($self, $MODE, $FORMAT) = @_;
	my $TIME;

	if($MODE eq "now"){
		$TIME = time;
	}else{
		$TIME = $MODE;
	}

	my @GMT = gmtime($TIME);

	$GMT[7] = ('', '', '', '', '', '', '')[$GMT[6]];
	$GMT[8] = ('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday')[$GMT[6]];
	$GMT[9] = ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat')[$GMT[6]];
	$GMT[10] = ('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December')[$GMT[4]];
	$GMT[11] = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec')[$GMT[4]];

	$GMT[5] += 1900;
	$GMT[12] = $GMT[5];
	$GMT[12] =~ s/^\d+?(\d\d)$/$1/;

	$GMT[4]++;

	my ($xss, $xsss, $xst, $xstt);
	if($GMT[3] < 11){
		$xss = 0;
		$xsss = 1;
		$xst = 'a';
		$xstt = 'A';
	}elsif($GMT[3] < 21){
		$xss = 1;
		$xsss = 2;
		$xst = 'b';
		$xstt = 'B';
	}elsif($GMT[3] < 32){
		$xss = 2;
		$xsss = 3;
		$xst = 'c';
		$xstt = 'C';
	}

	if($MODE eq "null"){
		$FORMAT =~ s/%YYYY%/\-\-\-\-/g;
		$FORMAT =~ s/%YY%/\-\-/g;

		$FORMAT =~ s/%MM%/\-\-/g;
		$FORMAT =~ s/%DD%/\-\-/g;
		$FORMAT =~ s/%HH%/\-\-/g;
		$FORMAT =~ s/%TT%/\-\-/g;
		$FORMAT =~ s/%SS%/\-\-/g;

		$FORMAT =~ s/%mm%/\-\-/g;
		$FORMAT =~ s/%dd%/\-\-/g;
		$FORMAT =~ s/%hh%/\-\-/g;
		$FORMAT =~ s/%tt%/\-\-/g;
		$FORMAT =~ s/%ss%/\-\-/g;

		$FORMAT =~ s/%WW%/\-\-/g;
		$FORMAT =~ s/%EE%/\-\-\-\-\-\-/g;
		$FORMAT =~ s/%ee%/\-\-\-/g;
		$FORMAT =~ s/%NN%/\-\-\-\-\-\-/g;
		$FORMAT =~ s/%nn%/\-\-\-/g;

		$FORMAT =~ s/%XX%/\-\-\-\-\-\-\-\-\-\-/g;

		$FORMAT =~ s/%UU%/\-/g;
		$FORMAT =~ s/%uu%/\-/g;
		$FORMAT =~ s/%VV%/\-/g;
		$FORMAT =~ s/%vv%/\-/g;

	}else{
		$FORMAT =~ s/%YYYY%/$GMT[5]/g;
		$FORMAT =~ s/%YY%/$GMT[12]/g;

		$FORMAT =~ s/%mm%/$GMT[4]/g;
		$FORMAT =~ s/%dd%/$GMT[3]/g;
		$FORMAT =~ s/%hh%/$GMT[2]/g;
		$FORMAT =~ s/%tt%/$GMT[1]/g;
		$FORMAT =~ s/%ss%/$GMT[0]/g;

		$GMT[4] = "0$GMT[4]" if($GMT[4] <= 9);
		$FORMAT =~ s/%MM%/$GMT[4]/g;
		$GMT[3] = "0$GMT[3]" if($GMT[3] <= 9);
		$FORMAT =~ s/%DD%/$GMT[3]/g;
		$GMT[2] = "0$GMT[2]" if($GMT[2] <= 9);
		$FORMAT =~ s/%HH%/$GMT[2]/g;
		$GMT[1] = "0$GMT[1]" if($GMT[1] <= 9);
		$FORMAT =~ s/%TT%/$GMT[1]/g;
		$GMT[0] = "0$GMT[0]" if($GMT[0] <= 9);
		$FORMAT =~ s/%SS%/$GMT[0]/g;

		$FORMAT =~ s/%WW%/$GMT[7]/g;
		$FORMAT =~ s/%EE%/$GMT[8]/g;
		$FORMAT =~ s/%ee%/$GMT[9]/g;
		$FORMAT =~ s/%NN%/$GMT[10]/g;
		$FORMAT =~ s/%nn%/$GMT[11]/g;

		$FORMAT =~ s/%XX%/$TIME/g;

		$FORMAT =~ s/%UU%/$xss/g;
		$FORMAT =~ s/%uu%/$xsss/g;
		$FORMAT =~ s/%VV%/$xst/g;
		$FORMAT =~ s/%vv%/$xstt/g;
	}

	$FORMAT;
}



1;

