package parseLIRS;

require 5.004;
use strict;

use nm::files;
use nm::times;
use LIRS;

$nm::parseLIRS::version = q(1.00);

my $Files = new nm::files;
my $LIRS = new LIRS;


sub ver{
	return $nm::parseLIRS::version;
}


sub parse{
	my $conf = shift;

print "\012\"parseLIRS::parse\" start\012";

	@nm::cf::ps::options = ();
	$nm::cf::ps::in = undef;
	$nm::cf::ps::exclusive = undef;

	my $deflirs;

print "read cfg file: $nm::cf::bin$conf\012";
	require qq($nm::cf::bin$conf);
	delete($INC{qq($nm::cf::bin$conf)});

	$nm::now = time;

	# եɤ߹
	my @dat = $Files->read_file("$nm::cf::ext$nm::cf::ps::in", $nm::cf::os);
print "read base LIRS file: $nm::cf::ext$nm::cf::ps::in\012";

	# LIRSեκ
print "  delete old LIRS files\012";
	for(@nm::cf::ps::options){
		my ($opt, $target) = split(/\|\|/);
		unlink("$nm::cf::ext$target");
		if($opt eq "*"){
			$deflirs = $target;
		}
print "  output LIRS file $target\012";
	}

	# ե
	for(@dat){
		my $data = $_;
		my $lirs = ($LIRS->tolist($data))[8];
		my $op = (split(",", $lirs))[3];
		my $a = 0;
		my $end = "";

		for(@nm::cf::ps::options){
			my ($opt, $target) = split(/\|\|/);
			next if($opt eq "*");
			if($op =~ /$opt/){
				if($end =~ /$target/i){
					next;
				}else{
					$Files->add_file("$nm::cf::ext$target", $data, $nm::cf::os);
					$a = 1;
					$end .= $target;
					if($nm::cf::ps::exclusive eq "no"){
						last;
					}
				}
			}
		}
		if($a == 0 && $deflirs){
			$Files->add_file("${nm::cf::ext}$deflirs", $data, $nm::cf::os);
		}
	}

print "\"parseLIRS::parse\" end\012";
}


sub marge{
	my $conf = shift;

print "\012\"parseLIRS::marge\" start\012";

print "read cfg file: $nm::cf::bin$conf\012";
	require qq($nm::cf::bin$conf);
	delete($INC{qq($nm::cf::bin$conf)});

	# ȤꤢΥեϺƤ
	unlink("${nm::cf::ext}$nm::cf::mg::output");

	# եɤ߹
	foreach my $f (@nm::cf::mg::input){
		my $dat = $Files->read_file("${nm::cf::ext}$f", $nm::cf::os);
		$Files->add_file("${nm::cf::ext}$nm::cf::mg::output", $dat, $nm::cf::os);

print "  add LIRS file $nm::cf::mg::output from $f\012";
	}

print "\"parseLIRS::marge\" end\012";
}



1;

